<?php
#
# HLstatsX - Real-time player and clan rankings and statistics for Half-Life:Source
# http://www.hlstatsx.com/
# Copyright (C) 2005 Tobias Oetzel (Tobi@hlstatsx.com)
#
# HlstatsX is an enhanced version of HLstats made by Simon Garner
# HLstats - Real-time player and clan rankings and statistics for Half-Life
# http://sourceforge.net/projects/hlstats/
# Copyright (C) 2001  Simon Garner
#             
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# motd.inc - showing ingame a statistic summary on connect
# ------------------------------------------------------------------------------------
# Created by Gregor Haenel (webmaster@flashman1986.de)
#
#

  // Message of the day
  
  //
  // General
  //
  $game="css";  
  $db->query("SELECT name FROM hlstats_Games WHERE code='$game'");
	if ($db->num_rows() < 1) error("No such game '$game'.");
	
	list($gamename) = $db->fetch_row();
	$db->free_result();
	
	$minkills = 1;
  $minmembers = 2;
  
  $players = 1;  
  if ((isset($_GET['players'])) && (is_numeric($_GET['players'])))
    $players = $_GET['players'];
  
  $clans = 1;  
  if ((isset($_GET['clans'])) && (is_numeric($_GET['clans'])))
    $clans = $_GET['clans'];
  
  $weapons = 0;  
  if ((isset($_GET['weapons'])) && (is_numeric($_GET['weapons'])))
    $weapons = $_GET['weapons'];
  
  $servers = 1;  
  if ((isset($_GET['servers'])) && (is_numeric($_GET['servers'])))
    $servers = $_GET['servers'];

  //
  // Top 10 Players
  //
  if($players > 0) {  
    $table_players = new Table(
  		array(
  			new TableColumn(
  				"lastName",
  				"Playername",
  				"width=45&icon=player"
  			),
  			new TableColumn(
  				"skill",
  				"Points",
  				"width=20&align=center"
  			),
  			new TableColumn(
  				"hpk",
  				"Hpk",
  				"width=15&align=center"
  			),
	        new TableColumn(
    	      "kpd",
        	  "Kpd",
	          "width=15&align=center"
    	    ),
  		),
      "playerID",
  		"skill",
      true,
      10
  	);
  	  
  	$result_players = $db->query("
  		SELECT
  			lastName,
  			skill,
  			IFNULL(kills/deaths, '-') AS kpd,
  			IFNULL(headshots/kills, '-') AS hpk,
        IF(".MINACTIVITY." > (UNIX_TIMESTAMP() - last_event), ((100/".MINACTIVITY.") * (".MINACTIVITY." - (UNIX_TIMESTAMP() - last_event))), 0) as activity
  		FROM
  			hlstats_Players
  		WHERE
  			game='$game'
  			AND hideranking=0
  			AND kills >= $minkills
      HAVING activity > 0
  		ORDER BY
  			$table_players->sort $table_players->sortorder
  		LIMIT 0,10
  	");
    $table_players->draw($result_players, 3, 100);
  }
  
  
  //
  // Top 3 Clans
  //
  if($clans > 0) {
  	$table_clans = new Table(
  		array(
  			new TableColumn(
  				"name",
  				"Clanname",
  				"width=45&icon=clan"
  			),
  			new TableColumn(
  				"tag",
  				"Tag",
  				"width=20&align=center"
  			),
  			new TableColumn(
  				"skill",
  				"Points",
  				"width=15&align=center"
  			),
  			new TableColumn(
  				"nummembers",
  				"Members",
  				"width=15&align=center"
  			),
  		),
  		"clanId",
  		"skill",
  		"kpd",
      true,
      3
  	);
  
  	$result_clans = $db->query("
  		SELECT
  			hlstats_Clans.clanId,
  			hlstats_Clans.name,
  			hlstats_Clans.tag,
  			COUNT(hlstats_Players.playerId) AS nummembers,
  			ROUND(AVG(hlstats_Players.skill)) AS skill
  		FROM
  			hlstats_Clans
  		LEFT JOIN hlstats_Players ON
  			hlstats_Players.clan=hlstats_Clans.clanId
  		WHERE
  			hlstats_Clans.game='$game'
  		GROUP BY
  			hlstats_Clans.clanId
  		HAVING
  			nummembers >= $minmembers
  		ORDER BY
  			$table_clans->sort $table_clans->sortorder
  		LIMIT 0,3
    ");
    $table_clans->draw($result_clans, 3, 100);
  }
  
  //
  // Weapon Statistics
	//
  if ($weapons > 0)  {  
	  $table_weapons = new Table(
		  array(
			  new TableColumn(
				  "weapon",
				  "Weaponname",
				  "width=45&type=weaponimg"
			  ),
			  new TableColumn(
				  "kills",
				  "Kills",
				  "width=20&align=center"
			  ),
			  new TableColumn(
				  "headshots",
				  "Headshots",
  				"width=15&align=center"
  		   	  ),
	  		  new TableColumn(
  				"hpk",
  				"Hpk",
  				"width=15&align=center"
  			  )
			
  		),
  		"weapon",
  		"kills",
  		true,
  		3
  	);
	
  	$db->query("
  		SELECT
  			COUNT(*)
  		FROM
  			hlstats_Events_Frags,
  			hlstats_Servers		
  		WHERE
  			hlstats_Servers.serverId = hlstats_Events_Frags.serverId AND
  			hlstats_Servers.game = '$game'
  	");
  	list($realkills) = $db->fetch_row();
  	
    $db->query("
  	 	SELECT
  			COUNT(*)
  		FROM
  			hlstats_Events_Frags,
  			hlstats_Servers		
  		WHERE
  			hlstats_Servers.serverId = hlstats_Events_Frags.serverId AND
  			hlstats_Servers.game = '$game' AND headshot=1
  	");
  	list($realheadshots) = $db->fetch_row();
  
    $result_weapons = $db->query("
      SELECT
        hlstats_Events_Frags.weapon,
        COUNT(hlstats_Events_Frags.weapon) AS kills,
        SUM(hlstats_Events_Frags.headshot=1) as headshots,
        SUM(hlstats_Events_Frags.headshot=1) / COUNT(hlstats_Events_Frags.weapon) AS hpk
      FROM
        hlstats_Events_Frags,
        hlstats_Weapons
      WHERE
        hlstats_Events_Frags.weapon = hlstats_Weapons.code AND
        hlstats_Weapons.game='$game'
      GROUP BY
        hlstats_Events_Frags.weapon
      ORDER BY
        $table_weapons->sort $table_weapons->sortorder
      LIMIT 0,3
    ");
    $table_weapons->draw($result_weapons, 5, 100);
  }

  //
  // Servers
  //
  if ($servers > 0)  {
    $table_servers = new Table(
      array(
	  	  new TableColumn(
	  			"name",
		  		"Servername",
		  		"width=50&icon=server"
		  	),
        new TableColumn(
			  	"addr",
			  	"Address",
			  	"width=20&align=right"
			  ),
        new TableColumn(
				  "act_map",
				  "Map",
				  "width=15&align=center"
			  ),
        new TableColumn(
			  	"act_players",
				  "Players",
				  "width=10&align=center"
			  ),
		  ),
		  "kills",
      "headshots",
      true,
      9999
	  );
  
    $result_servers = $db->query("
      SELECT
        name,
        IF(publicaddress != '',
          publicaddress,
          concat(address, ':', port)
        ) AS addr,              
        act_players,
        act_map                
      FROM
        hlstats_Servers
      WHERE
        game='$game'
      ORDER BY
        $table_servers->sort $table_servers->sortorder
    ");
    $table_servers->draw($result_servers, 10, 100);
  }
?>